'use strict';

var path = require('path');
var isBuiltinModule = require('is-builtin-module');
var options = require('@rollup-extras/utils/options');
var logger = require('@rollup-extras/utils/logger');

const factories = { logger };
function index (options$1 = {}) {
    const { pluginName, external, logger, verbose } = options.getOptionsObject(options$1, {
        pluginName: '@rollup-extras/plugin-externals',
        verbose: false
    }, factories);
    const logLevel = verbose ? 1 /* LogLevel.info */ : 0 /* LogLevel.verbose */;
    return {
        name: pluginName,
        resolveId(id) {
            let isExternal = id.includes('node_modules') || isBuiltinModule(id) || path.relative('.', id).startsWith('..');
            if (external) {
                isExternal = external(id, isExternal);
            }
            logger(`'${id}' is ${isExternal ? '' : 'not '}external`, logLevel);
            return isExternal ? false : null;
        }
    };
}

module.exports = index;
