import path from 'path';
import isBuiltinModule from 'is-builtin-module';
import { getOptionsObject } from '@rollup-extras/utils/options';
import logger from '@rollup-extras/utils/logger';

const factories = { logger };
function index (options = {}) {
    const { pluginName, external, logger, verbose } = getOptionsObject(options, {
        pluginName: '@rollup-extras/plugin-externals',
        verbose: false
    }, factories);
    const logLevel = verbose ? 1 /* LogLevel.info */ : 0 /* LogLevel.verbose */;
    return {
        name: pluginName,
        resolveId(id) {
            let isExternal = id.includes('node_modules') || isBuiltinModule(id) || path.relative('.', id).startsWith('..');
            if (external) {
                isExternal = external(id, isExternal);
            }
            logger(`'${id}' is ${isExternal ? '' : 'not '}external`, logLevel);
            return isExternal ? false : null;
        }
    };
}

export { index as default };
